//+------------------------------------------------------------------+
//| WhiteChristmas_2009_Script_v1
//+------------------------------------------------------------------+
#property copyright "Copyright(c)2009 latimeria"
#property show_inputs

// Links for multi language

// http://www.infostarbase.com/tnr/xmas/merry.html
// http://www.navidadlatina.com/idiomas/

// Links for multi language "Silent Night"

// German & English version  http://www.soundpie.com/hymn/109.htm
// French / Spanish / Italian / Norwegian version  http://www.visit-salzburg.net/travel/silentnightlyrics.htm
// more and more  http://www.silentnight.web.za/translate/

//extern string  ModeExp = "<<< Mode Select >>>";
extern string  ModeNote_1 = "1=Message 2=Hymn";

extern string  MultiLanguageExp = "<<< Message >>>";
//extern int     Select_Language = 99;
extern string  LangNote_1 = "1=ENG 2=FRA 3=ESP 4=GER 5=RUS 6=ITA";
extern string  LangNote_2 = "7=Hindi 8=Mandarin 9=Iraqi 10=Hawaiian";
extern string  LangNote_3 = "11=Suomeksi 12=Swahili 13=Tagalog";
extern string  LangNote_4 = "14=Uzbek 15=Czech 16=Greek 17=Turkish";
extern string  LangNote_5 = "18=Punjabi 19=Euskera 20=Esperanto";
extern string  LangNote_9 = "99=Loop";
extern string  CustomMessage = "enter your words here";

extern string  HymnExp = "<<< Hymn (Silent Night & more) >>>";
extern string  Hymnnote_1 = "1=GER 2=ENG 3=FRA 4=ESP 5=ITA";
extern string  Hymnnote_2 = "6=Norwegian 7=Tahitian 8=Hindi 9=Euskera";
extern string  Hymnnote_3 = "10=Swahili 11=Indonesian 12=Maori";
extern string  Hymnnote_4 = "13=Hungarian 14=Irish";
extern string  Hymnnote_5 = "20=Esperanto";
extern string  Hymnnote_6 = "51=WhiteXmas 52=StClausIsComing";
extern string  Hymnnote_9 = "99=LoopMerryChristmas";
//int     Select_Song = 1;

extern string  MiscellaneousExp = "<<< Miscellaneous >>>";
extern string  Font = "Arial Bold";
extern color   FontColor = White;

string Multi_Lang [] = { "",
                         "Merry Christmas", // ENG
                         "Joyeux Noel", // FRA
                         "Feliz Navidad", // ESP
                         "Froehliche Weihnachten", // GER
                         "S Rozhdestvom Kristovym", // RUS

                         "Buon Natale", // ITA
                         "Shub Badadin", // Hindi
                         "Sheng Dankuai Le", // Mandarin
                         "Idah Saidan Wa Sanah Jadidah", // Iraqi
                         "Mele Kalikimaka", // Hawaiian

                         "Hauskaa Joulua", // Suomeksi
                         "Heri ya Krismasi", // Swahili
                         "Maligayang Pasko", // Tagalog
                         "Yangi Yiligiz Mubarak Bolsun", // Uzbek
                         "Velike Vanoce", // Czech
                         
                         "Kala Christouyenna", // Greek
                         "Noeliniz Ve Yeni Yiliniz Kutlu Olsun", // Turkish
                         "Hacahi Ke Eide", // Punjabi
                         "Zorionak eta Urte Berri On", // Euskera
                         "Gojan Kristnaskon" // Esperanto
                       };

string Language [] = { "",
                         "English","Francaise","Espagnol","Deutsch","Ruski",
                         "Italiano","Hindi","Chinese (Mandarin)", "Iraqi","Hawaiian",
                         "Suomeksi", "Swahili","Tagalog","Uzbek","Czech",
                         "Greek","Turkish","Punjabi","Euskera", "Esperanto"
                       };

bool SIGNAL;
bool Prev_SIGNAL;

int CurTiming;

// Snow Variables
double Window_Range;
double Scale_Factor;
int WindowBars;

// GV Names
// GVs for General Settings
string sGV_SETTINGS_00;
string sGV_ShowTree;
string sGV_ShowSnow;
string sGV_Text_Mode;
string sGV_Select_MessageLang;
string sGV_Select_Song;
string sGV_ShowCurrentLanguage;
string sGV_Text_Interval_Sec;
string sGV_Refresh_MilliSec;
string sGV_ResetGV;

// GVs for Graphics Main
string sGV_SETTINGS_10;
string sGV_TreeWidth;
string sGV_AutoHeight_Ratio;
string sGV_Scale_Factor;
string sGV_SnowFlakes;

// GVs for Auto or Manual Tree Axis
string sGV_SETTINGS_20;
string sGV_TreeTop_Price;
string sGV_TreeBottom_Price;
string sGV_ManualBarShift;

// GVs for Text
string sGV_SETTINGS_30;
string sGV_Randomize;
string sGV_RndText_Max;
string sGV_RndText_Min;
string sGV_Manual_FontSize;
string sGV_TextCorner;
string sGV_TextLineShift;


// Variables for Prev Value
int Prev_ShowTree;
double Prev_WidthIncrement;
int Prev_AutoHeight;
double Prev_AutoHeight_Ratio;
double Prev_TreeTop_Price;
double Prev_TreeBottom_Price;
int Prev_DrawCenter;
int Prev_BarShift;
int Prev_SnowFlakes;

// Prev Chart Value
double Prev_WinPriceMax;
double Prev_WinPriceMin;
int Prev_WinBars;
int Prev_FirstBar;

int x[];
double y[];
double size[];
int Amplitude[];

int DQ_ADJUST []  = { 0 , 0 , 1 , 10 , 1 , 10 };
int DQADJ;

int Dir[];
int j[];
int Speed[];

string ObjNameBase = "Noel_";

double TreeTop, TreeBottom, AutoHeight_Ratio;
int Base; int Left_1, Left_2, Left_3, Left_4; int Right_1, Right_2, Right_3, Right_4; 
double Top_2, Top_3;

int MILLISEC_COUNTER;

//+------------------------------------------------------------------+
//| init
//+------------------------------------------------------------------+
int init()
{
   for(int i=0; i<100; i++) DelObjects(ObjNameBase);
   
   MathSrand(TimeLocal());

   DQADJ = DQ_ADJUST [ Digits ];

   Range_and_Bar_Reset();

   // GVs for General Settings
   sGV_SETTINGS_00 = "Noel_00  --------------";
   if( GlobalVariableCheck(sGV_SETTINGS_00) == 0 ) GlobalVariableSet(sGV_SETTINGS_00, EMPTY); // General Settings
   sGV_ShowTree = "Noel_01_ShowTree_1=true";
   if( GlobalVariableCheck(sGV_ShowTree) == 0 ) GlobalVariableSet(sGV_ShowTree, 1); // ShowTree
   sGV_ShowSnow = "Noel_02_Snowing_1=true";
   if( GlobalVariableCheck(sGV_ShowSnow) == 0 ) GlobalVariableSet(sGV_ShowSnow, 1); // ShowSnow
   sGV_Text_Mode = "Noel_03_Mode_1=Message_2=Hymn";
   if( GlobalVariableCheck(sGV_Text_Mode) == 0 ) GlobalVariableSet(sGV_Text_Mode, 2); // Mode
   sGV_Select_MessageLang = "Noel_04_Select_MessageLang";
   if( GlobalVariableCheck(sGV_Select_MessageLang) == 0 ) GlobalVariableSet(sGV_Select_MessageLang, 99); // Select_MessageLang
   sGV_Select_Song = "Noel_05_Select_Song";
   if( GlobalVariableCheck(sGV_Select_Song) == 0 ) GlobalVariableSet(sGV_Select_Song, 1); // Select_Song
   sGV_ShowCurrentLanguage = "Noel_06_ShowCurLang_1=true";
   if( GlobalVariableCheck(sGV_ShowCurrentLanguage) == 0 ) GlobalVariableSet(sGV_ShowCurrentLanguage, 1); // ShowCurLang
   sGV_Text_Interval_Sec = "Noel_07_Text_Interval_Sec";
   if( GlobalVariableCheck(sGV_Text_Interval_Sec) == 0 ) GlobalVariableSet(sGV_Text_Interval_Sec, 7); // Text_Interval_Sec
   sGV_Refresh_MilliSec = "Noel_08_Refresh_MilliSec";
   if( GlobalVariableCheck(sGV_Refresh_MilliSec) == 0 ) GlobalVariableSet(sGV_Refresh_MilliSec, 1000); // Refresh_MilliSec
   sGV_ResetGV = "Noel_09_ResetGV_1=true";
   if( GlobalVariableCheck(sGV_ResetGV) == 0 ) GlobalVariableSet(sGV_ResetGV, 0); // ResetGV

   // GVs for Graphics Main
   sGV_SETTINGS_10 = "Noel_10  --------------";
   if( GlobalVariableCheck(sGV_SETTINGS_10) == 0 ) GlobalVariableSet(sGV_SETTINGS_10, EMPTY); // Tree Axis Settings
   sGV_TreeWidth = "Noel_11_Tree_Width"; // GV for Tree X-Scale
   if( GlobalVariableCheck(sGV_TreeWidth) == 0 ) GlobalVariableSet(sGV_TreeWidth, 20); // Width_Increment
   sGV_AutoHeight_Ratio = "Noel_12_AutoHeight_Ratio";
   if( GlobalVariableCheck(sGV_AutoHeight_Ratio) == 0 ) GlobalVariableSet(sGV_AutoHeight_Ratio, 0.33); // AutoHeight_Ratio
   sGV_Scale_Factor = "Noel_13_Snow_Scale_Factor"; // GV for Snow ScaleFactor
   if( GlobalVariableCheck(sGV_Scale_Factor) == 0 ) GlobalVariableSet(sGV_Scale_Factor, 0.05); // Snow_Scale_Factor
   sGV_SnowFlakes = "Noel_14_SnowFlakes";
   if( GlobalVariableCheck(sGV_SnowFlakes) == 0 ) GlobalVariableSet(sGV_SnowFlakes, 20); // SnowFlakes

   // GVs for Manual Tree Axis
   sGV_SETTINGS_20 = "Noel_20  --------------";
   if( GlobalVariableCheck(sGV_SETTINGS_20) == 0 ) GlobalVariableSet(sGV_SETTINGS_20, EMPTY); // Tree Axis Settings
   sGV_TreeTop_Price = "Noel_21_Manual_TreeTop_Price";
   if( GlobalVariableCheck(sGV_TreeTop_Price) == 0 ) GlobalVariableSet(sGV_TreeTop_Price, 0.0000); // TreeTop_Price
   sGV_TreeBottom_Price = "Noel_22_Manual_TreeBottom_Price";
   if( GlobalVariableCheck(sGV_TreeBottom_Price) == 0 ) GlobalVariableSet(sGV_TreeBottom_Price, 0.0000); // TreeBottom_Price
   sGV_ManualBarShift = "Noel_23_ManualBarShift";
   if( GlobalVariableCheck(sGV_ManualBarShift) == 0 ) GlobalVariableSet(sGV_ManualBarShift, 0); // ManualBarShift

   // GVs for Text
   sGV_SETTINGS_30 = "Noel_30  --------------";
   if( GlobalVariableCheck(sGV_SETTINGS_30) == 0 ) GlobalVariableSet(sGV_SETTINGS_30, EMPTY); // Text Settings
   sGV_Randomize = "Noel_21_Randomize_Text_1=true";
   if( GlobalVariableCheck(sGV_Randomize) == 0 ) GlobalVariableSet(sGV_Randomize, 1); // Randomize_Text
   sGV_RndText_Max = "Noel_22_RndText_Max";
   if( GlobalVariableCheck(sGV_RndText_Max) == 0 ) GlobalVariableSet(sGV_RndText_Max, 28); // RndText_Max
   sGV_RndText_Min = "Noel_23_RndText_Min";
   if( GlobalVariableCheck(sGV_RndText_Min) == 0 ) GlobalVariableSet(sGV_RndText_Min, 12); // RndText_Min
   sGV_Manual_FontSize = "Noel_24_FontSize";
   if( GlobalVariableCheck(sGV_Manual_FontSize) == 0 ) GlobalVariableSet(sGV_Manual_FontSize, 12); // Manual_FontSize
   sGV_TextCorner = "Noel_25_TextCorner";
   if( GlobalVariableCheck(sGV_TextCorner) == 0 ) GlobalVariableSet(sGV_TextCorner, 2); // TextCorner
   sGV_TextLineShift = "Noel_26_TextLineShift";
   if( GlobalVariableCheck(sGV_TextLineShift) == 0 ) GlobalVariableSet(sGV_TextLineShift, 0); // TextLineShift

   return(0);
}

//+------------------------------------------------------------------+
//| Initialize_GV
//+------------------------------------------------------------------+
void Initialize_GV()
{
   // GVs for General Settings
   GlobalVariableSet(sGV_SETTINGS_00, EMPTY); // General Settings
   GlobalVariableSet(sGV_ShowTree, 1); // ShowTree
   GlobalVariableSet(sGV_ShowSnow, 1); // ShowSnow
   GlobalVariableSet(sGV_Text_Mode, 2); // Mode
   GlobalVariableSet(sGV_Select_MessageLang, 99); // Select_MessageLang
   GlobalVariableSet(sGV_Select_Song, 1); // Select_Song
   GlobalVariableSet(sGV_ShowCurrentLanguage, 1); // ShowCurLang
   GlobalVariableSet(sGV_Text_Interval_Sec, 7); // Text_Interval_Sec
   GlobalVariableSet(sGV_Refresh_MilliSec, 1000); // Refresh_MilliSec
   GlobalVariableSet(sGV_ResetGV, 0); // ResetGV

   // GVs for Graphics Main
   GlobalVariableSet(sGV_SETTINGS_10, EMPTY); // Tree Axis Settings
   GlobalVariableSet(sGV_TreeWidth, 20); // Width_Increment
   GlobalVariableSet(sGV_AutoHeight_Ratio, 0.33); // AutoHeight_Ratio
   GlobalVariableSet(sGV_Scale_Factor, 0.05); // Snow_Scale_Factor
   GlobalVariableSet(sGV_SnowFlakes, 20); // SnowFlakes

   // GVs for Manual Tree Axis
   GlobalVariableSet(sGV_SETTINGS_20, EMPTY); // Tree Axis Settings
   GlobalVariableSet(sGV_TreeTop_Price, 0.0000); // TreeTop_Price
   GlobalVariableSet(sGV_TreeBottom_Price, 0.0000); // TreeBottom_Price
   GlobalVariableSet(sGV_ManualBarShift, 0); // ManualBarShift

   // GVs for Text
   GlobalVariableSet(sGV_SETTINGS_30, EMPTY); // Text Settings
   GlobalVariableSet(sGV_Randomize, 1); // Randomize_Text
   GlobalVariableSet(sGV_RndText_Max, 28); // RndText_Max
   GlobalVariableSet(sGV_RndText_Min, 12); // RndText_Min
   GlobalVariableSet(sGV_Manual_FontSize, 12); // Manual_FontSize
   GlobalVariableSet(sGV_TextCorner, 2); // TextCorner
   GlobalVariableSet(sGV_TextLineShift, 0); // TextLineShift
}

//+------------------------------------------------------------------+
//| deinit
//+------------------------------------------------------------------+
int deinit()
{
   for(int i=0; i<100; i++) DelObjects(ObjNameBase);

   Comment("");
   return(0);
}

//+------------------------------------------------------------------+
//| start
//+------------------------------------------------------------------+
int start()
{
   int SHOW_TREE = GlobalVariableGet(sGV_ShowTree);

   if(SHOW_TREE == 1) DrawChristmasTree();
   PermanentLoop();
   return(0);
}

//+------------------------------------------------------------------+
//| DrawCristmasTree
//+------------------------------------------------------------------+
void DrawChristmasTree()
{
   Range_and_Bar_Reset();

   int i; int ObjIndex = 1; string BaseName;
   
   double GV_TREE_TOP = GlobalVariableGet(sGV_TreeTop_Price);
   double GV_TREE_BOTTOM = GlobalVariableGet(sGV_TreeBottom_Price);

   double WP_MAX = WindowPriceMax(); double WP_MIN = WindowPriceMin();

   bool MANUAL_HEIGHT = false;
   if( (GV_TREE_TOP < WP_MAX && GV_TREE_TOP > WP_MIN) && (GV_TREE_BOTTOM < WP_MAX && GV_TREE_BOTTOM > WP_MIN) && (GV_TREE_TOP > GV_TREE_BOTTOM) ) MANUAL_HEIGHT = true;
   
   if( MANUAL_HEIGHT ) // Manual
   {
      TreeTop = GV_TREE_TOP;
      TreeBottom = GV_TREE_BOTTOM;
   }
   else // Auto
   {
      AutoHeight_Ratio = GlobalVariableGet(sGV_AutoHeight_Ratio);
      if(AutoHeight_Ratio > 0.6) AutoHeight_Ratio = 0.6;
      if(AutoHeight_Ratio < 0.1) AutoHeight_Ratio = 0.1;

      double Distance_from_MaxMin = ( Window_Range * (1.0 - AutoHeight_Ratio) ) / 2.0;
      TreeTop = WP_MAX - Distance_from_MaxMin;
      TreeBottom = WP_MIN + Distance_from_MaxMin;
   }

   int GV_MANUAL_BARSHIFT = GlobalVariableGet(sGV_ManualBarShift);
   if(GV_MANUAL_BARSHIFT < 1) Base = WindowBarsPerChart()/2; // Auto
   else Base = GV_MANUAL_BARSHIFT; // Manual
   
   double TreeDivide = (TreeTop - TreeBottom) / 3.0;

   double GV_Width_Increment = GlobalVariableGet(sGV_TreeWidth);
   if(GV_Width_Increment < 7) GV_Width_Increment = 7;

   int Increment_1 = GV_Width_Increment;
   double dIncrement_2 = GV_Width_Increment * 1.71; int Increment_2 = dIncrement_2;
   double dIncrement_3 = dIncrement_2 * 1.45; int Increment_3 = dIncrement_3; 

   double Width_Multiple = GV_Width_Increment/7.0;

   // Object Variables
   datetime TIME_1, TIME_2, TIME_3; double PRICE_1, PRICE_2, PRICE_3; color COL;
   bool BackGround = true; string Text = "";
   
// Leaf ------------------------------------------------------------

   BaseName = ObjNameBase +"Leaf_";
   COL = Green; // color for Leaf
   
   double Bottom_1 = TreeBottom + TreeDivide*2;

   int Tree_Right_1 = Base - Increment_1;
   int Tree_Left_1 = Base + Increment_1;

   TIME_1 = Time[ Tree_Right_1 ]; TIME_2 = Time[ Tree_Left_1 ]; TIME_3 = Time[ Base ];
   PRICE_1 = Bottom_1; PRICE_2 = Bottom_1; PRICE_3 = TreeTop;
   CreateTriangle(BaseName+ObjIndex, TIME_1, PRICE_1, TIME_2, PRICE_2, TIME_3, PRICE_3, COL, Text, BackGround); ObjIndex ++;

// Leaf2 ------------------------------------------------------------

   Top_2 = Bottom_1;
   double Bottom_2 = TreeBottom + TreeDivide;
   
   int Tree_Right_2 = Base - Increment_2;
   int Tree_Left_2 = Base + Increment_2;

   double dLeaf1_Shift = 3.0*Width_Multiple; int Leaf1_Shift = dLeaf1_Shift;
   int Bar_Upper_L = Tree_Left_1 - Leaf1_Shift;
   int Bar_Upper_R = Tree_Right_1 + Leaf1_Shift;
   
   // Leaf2-1
   TIME_1 = Time[ Bar_Upper_R ]; TIME_2 = Time[ Bar_Upper_L ]; TIME_3 = Time[ Base ];
   PRICE_1 = Top_2; PRICE_2 = Top_2; PRICE_3 = Bottom_2;
   CreateTriangle(BaseName+ObjIndex, TIME_1, PRICE_1, TIME_2, PRICE_2, TIME_3, PRICE_3, COL, Text, BackGround); ObjIndex ++;

   // Leaf2-2
   TIME_1 = Time[ Bar_Upper_R ]; TIME_2 = Time[ Tree_Right_2 ]; TIME_3 = Time[ Base ];
   PRICE_1 = Top_2; PRICE_2 = Bottom_2; PRICE_3 = Bottom_2;
   CreateTriangle(BaseName+ObjIndex, TIME_1, PRICE_1, TIME_2, PRICE_2, TIME_3, PRICE_3, COL, Text, BackGround); ObjIndex ++;

   // Leaf2-3
   TIME_1 = Time[ Bar_Upper_L ]; TIME_2 = Time[ Tree_Left_2 ]; TIME_3 = Time[ Base ];
   PRICE_1 = Top_2; PRICE_2 = Bottom_2; PRICE_3 = Bottom_2;
   CreateTriangle(BaseName+ObjIndex, TIME_1, PRICE_1, TIME_2, PRICE_2, TIME_3, PRICE_3, COL, Text, BackGround); ObjIndex ++;

// Leaf3 ------------------------------------------------------------

   Top_3 = Bottom_2;
   double Bottom_3 = TreeBottom;
   
   int Tree_Right_3 = Base-Increment_3;
   int Tree_Left_3 = Base+Increment_3;

   double dLeaf2_Shift = 3.5*Width_Multiple; int Leaf2_Shift = dLeaf2_Shift;
   int Bar_Upper_L2 = Tree_Left_2 - Leaf2_Shift;
   int Bar_Upper_R2 = Tree_Right_2 + Leaf2_Shift;

   // Leaf3-1
   TIME_1 = Time[ Bar_Upper_R2 ]; TIME_2 = Time[ Bar_Upper_L2 ]; TIME_3 = Time[ Base ];
   PRICE_1 = Top_3; PRICE_2 = Top_3; PRICE_3 = Bottom_3; 
   CreateTriangle(BaseName+ObjIndex, TIME_1, PRICE_1, TIME_2, PRICE_2, TIME_3, PRICE_3, COL, Text, BackGround); ObjIndex ++;

   // Leaf3-2
   TIME_1 = Time[ Bar_Upper_R2 ]; TIME_2 = Time[ Tree_Right_3 ]; TIME_3 = Time[ Base ];
   PRICE_1 = Top_3; PRICE_2 = Bottom_3; PRICE_3 = Bottom_3; 
   CreateTriangle(BaseName+ObjIndex, TIME_1, PRICE_1, TIME_2, PRICE_2, TIME_3, PRICE_3, COL, Text, BackGround); ObjIndex ++;

   // Leaf3-3
   TIME_1 = Time[ Bar_Upper_L2 ]; TIME_2 = Time[ Tree_Left_3 ]; TIME_3 = Time[ Base ];
   PRICE_1 = Top_3; PRICE_2 = Bottom_3; PRICE_3 = Bottom_3; 
   CreateTriangle(BaseName+ObjIndex, TIME_1, PRICE_1, TIME_2, PRICE_2, TIME_3, PRICE_3, COL, Text, BackGround); ObjIndex ++;

// Trunk ------------------------------------------------------------

   COL = SaddleBrown; // color for Trunk

   double TrunkLenghth = (TreeTop - TreeBottom)/6.0;
   double dTrunk_Shift = 2.0*Width_Multiple; int Trunk_Shift = dTrunk_Shift;
   
   TIME_1 = Time[ Base-Trunk_Shift ]; TIME_2 = Time[ Base+Trunk_Shift ];
   PRICE_1 = TreeBottom - TrunkLenghth; PRICE_2 = TreeBottom;
   CreateRectangle(ObjNameBase +"Trunk", TIME_1, PRICE_1, TIME_2, PRICE_2, COL, Text, BackGround);
   
// Star on the top ------------------------------------------------------------

   ObjIndex = 1;
   BaseName = ObjNameBase +"Star_";
   COL = Gold; // color for Star

   double StarTop = TreeTop + TreeDivide*0.8;
   double StarDivide = (TreeDivide*0.8)/11;

   double Level_1 = StarTop - StarDivide*4;
   double Level_2 = StarTop - StarDivide*7;
   double Level_3 = StarTop - StarDivide*9;
   double Level_Bottom = TreeTop;

   // Left
   double dLeft_1 = Base + 1.0*Width_Multiple; Left_1 = dLeft_1;
   double dLeft_2 = Base + 2.0*Width_Multiple; Left_2 = dLeft_2;
   double dLeft_3 = Base + 3.0*Width_Multiple; Left_3 = dLeft_3;
   double dLeft_4 = Base + 4.0*Width_Multiple; Left_4 = dLeft_4;

   // Right
   double dRight_1 = Base - 1.0*Width_Multiple; Right_1 = dRight_1;
   double dRight_2 = Base - 2.0*Width_Multiple; Right_2 = dRight_2;
   double dRight_3 = Base - 3.0*Width_Multiple; Right_3 = dRight_3;
   double dRight_4 = Base - 4.0*Width_Multiple; Right_4 = dRight_4;

   // Star1 - Top
   TIME_1 = Time[ Right_1 ]; TIME_2 = Time[ Left_1 ]; TIME_3 = Time[ Base ];
   PRICE_1 = Level_1; PRICE_2 = Level_1; PRICE_3 = StarTop; 
   CreateTriangle(BaseName+ObjIndex, TIME_1, PRICE_1, TIME_2, PRICE_2, TIME_3, PRICE_3, COL, Text, BackGround); ObjIndex ++;

   // Star2 - Left
   TIME_1 = Time[ Left_1 ]; TIME_2 = Time[ Left_4 ]; TIME_3 = Time[ Left_2 ];
   PRICE_1 = Level_1; PRICE_2 = Level_1; PRICE_3 = Level_2; 
   CreateTriangle(BaseName+ObjIndex, TIME_1, PRICE_1, TIME_2, PRICE_2, TIME_3, PRICE_3, COL, Text, BackGround); ObjIndex ++;
   
   // Star3 - Right
   TIME_1 = Time[ Right_1 ]; TIME_2 = Time[ Right_4 ]; TIME_3 = Time[ Right_2 ];
   //PRICE_1 = Level_1; PRICE_2 = Level_1; PRICE_3 = Level_2; 
   CreateTriangle(BaseName+ObjIndex, TIME_1, PRICE_1, TIME_2, PRICE_2, TIME_3, PRICE_3, COL, Text, BackGround); ObjIndex ++;
   
   // Star4 - Bottom Right
   TIME_1 = Time[ Base ]; TIME_2 = Time[ Right_3 ]; TIME_3 = Time[ Right_2 ];
   PRICE_1 = Level_3; PRICE_2 = Level_Bottom; PRICE_3 = Level_2; 
   CreateTriangle(BaseName+ObjIndex, TIME_1, PRICE_1, TIME_2, PRICE_2, TIME_3, PRICE_3, COL, Text, BackGround); ObjIndex ++;
   
   // Star5 - Bottom Left
   TIME_1 = Time[ Base ]; TIME_2 = Time[ Left_3 ]; TIME_3 = Time[ Left_2 ];
   //PRICE_1 = Level_3; PRICE_2 = Level_Bottom; PRICE_3 = Level_2;
   CreateTriangle(BaseName+ObjIndex, TIME_1, PRICE_1, TIME_2, PRICE_2, TIME_3, PRICE_3, COL, Text, BackGround); ObjIndex ++;

   // Star6 - Hole Left
   TIME_1 = Time[ Base ]; TIME_2 = Time[ Left_1 ]; TIME_3 = Time[ Left_2 ];
   PRICE_1 = Level_3; PRICE_2 = Level_1; PRICE_3 = Level_2; 
   CreateTriangle(BaseName+ObjIndex, TIME_1, PRICE_1, TIME_2, PRICE_2, TIME_3, PRICE_3, COL, Text, BackGround); ObjIndex ++;

   // Star7 - Hole Center
   TIME_1 = Time[ Right_1 ]; TIME_2 = Time[ Left_1 ]; TIME_3 = Time[ Base ];
   PRICE_1 = Level_1; PRICE_2 = Level_1; PRICE_3 = Level_3; 
   CreateTriangle(BaseName+ObjIndex, TIME_1, PRICE_1, TIME_2, PRICE_2, TIME_3, PRICE_3, COL, Text, BackGround); ObjIndex ++;

   // Star8 - Hole Right
   TIME_1 = Time[ Right_1 ]; TIME_2 = Time[ Right_2 ]; TIME_3 = Time[ Base ];
   PRICE_1 = Level_1; PRICE_2 = Level_2; PRICE_3 = Level_3; 
   CreateTriangle(BaseName+ObjIndex, TIME_1, PRICE_1, TIME_2, PRICE_2, TIME_3, PRICE_3, COL, Text, BackGround); ObjIndex ++;
}

//+------------------------------------------------------------------+
//| IsSameDouble
//+------------------------------------------------------------------+
bool IsSameDouble( double Val_1, double Val_2 )
{
   if( DoubleToStr(Val_1, 4) == DoubleToStr(Val_2, 4) ) return(true);
   else return(false);
}

//+------------------------------------------------------------------+
//| PermanentLoop
//+------------------------------------------------------------------+
void PermanentLoop()
{   
   int i; int ObjIndex; string BaseName;
   
   // Object Variables
   datetime TIME_1, TIME_2, TIME_3; double PRICE_1, PRICE_2, PRICE_3; color COL;
   bool BackGround = true; string Text = "";

   while( !IsStopped() )
   {
      int RESET_GV = GlobalVariableGet(sGV_ResetGV);
      if(RESET_GV == 1) Initialize_GV();

      int SHOW_TREE = GlobalVariableGet(sGV_ShowTree);

      if(SHOW_TREE == 1)
      {
         // Christmas Tree Redraw Check
         bool Redraw_Tree = false;

         if(Prev_ShowTree != SHOW_TREE) Redraw_Tree = true;

         // GV Check (Width_Increment)
         double Cur_WidthIncrement = GlobalVariableGet(sGV_TreeWidth);
         if( !IsSameDouble( Cur_WidthIncrement, Prev_WidthIncrement ) ) Redraw_Tree = true;
         Prev_WidthIncrement = Cur_WidthIncrement;

         // GV Check (AutoHeight_Ratio)
         double Cur_AutoHeight_Ratio = GlobalVariableGet(sGV_AutoHeight_Ratio);
         if(!Redraw_Tree) { if( !IsSameDouble( Cur_AutoHeight_Ratio, Prev_AutoHeight_Ratio ) ) Redraw_Tree = true; }
         Prev_AutoHeight_Ratio = Cur_AutoHeight_Ratio;

         // GV Check (Manual Height)
         double GV_TREE_TOP = GlobalVariableGet(sGV_TreeTop_Price);
         double GV_TREE_BOTTOM = GlobalVariableGet(sGV_TreeBottom_Price);
         if(!Redraw_Tree) { if( !IsSameDouble( GV_TREE_TOP, Prev_TreeTop_Price ) ) Redraw_Tree = true; }
         if(!Redraw_Tree) { if( !IsSameDouble( GV_TREE_BOTTOM, Prev_TreeBottom_Price ) ) Redraw_Tree = true; }

         Prev_TreeTop_Price = GV_TREE_TOP;
         Prev_TreeBottom_Price = GV_TREE_BOTTOM;

         // GV Check (ManualBarShift)
         int Cur_BarShift = GlobalVariableGet(sGV_ManualBarShift);
         if(!Redraw_Tree) { if( Cur_BarShift != Prev_BarShift ) Redraw_Tree = true; }
         Prev_BarShift = Cur_BarShift;

         // Chart Check (Price)
         double Cur_WinPriceMax = WindowPriceMax();
         if(!Redraw_Tree) { if( !IsSameDouble( Cur_WinPriceMax, Prev_WinPriceMax ) ) Redraw_Tree = true; }
         Prev_WinPriceMax = Cur_WinPriceMax;
         double Cur_WinPriceMin = WindowPriceMin();
         if(!Redraw_Tree) { if( !IsSameDouble( Cur_WinPriceMin, Prev_WinPriceMin ) ) Redraw_Tree = true; }
         Prev_WinPriceMin = Cur_WinPriceMin;

         // Chart Check (Bars)
         if(!Redraw_Tree) { int Cur_WinBars = WindowBarsPerChart(); if( Cur_WinBars != Prev_WinBars ) Redraw_Tree = true; }
         Prev_WinBars = WindowBarsPerChart();
         if(!Redraw_Tree) { int Cur_FirstBar = WindowFirstVisibleBar(); if( Cur_FirstBar != Prev_FirstBar ) Redraw_Tree = true; }
         Prev_FirstBar = WindowFirstVisibleBar();
   
         // Redraw
         if(Redraw_Tree) DrawChristmasTree();

         double dWidth_Multiple = Cur_WidthIncrement/7.0; int iWidth_Multiple = dWidth_Multiple;

         // Ornaments ------------------------------------------------------------
         BaseName = ObjNameBase +"Ornament_";
         color LIGHT_COL[] = { White, LightPink, Yellow, White, Yellow };

         double LightHeight = (TreeTop - TreeBottom)/40;

         // Ornament
         if( Prev_SIGNAL != SIGNAL )
         {
            ObjIndex = 1;
            if( SIGNAL )
            {
               // Light-1
               COL = LIGHT_COL[1];
               TIME_1 = Time[ Left_1 ]; TIME_2 = Time[ Base ];
               PRICE_1 = (TreeTop+Top_2)/2; PRICE_2 = PRICE_1 + LightHeight;
               CreateRectangle(BaseName+ObjIndex, TIME_1, PRICE_1, TIME_2, PRICE_2, COL, Text, BackGround); ObjIndex ++;

               // Light-2
               COL = LIGHT_COL[2];
               TIME_1 = Time[ Right_2 ]; TIME_2 = Time[ Right_1 ];
               PRICE_1 = Top_2; PRICE_2 = PRICE_1 + LightHeight;
               CreateRectangle(BaseName+ObjIndex, TIME_1, PRICE_1, TIME_2, PRICE_2, COL, Text, BackGround); ObjIndex ++;

               // Light-3
               COL = LIGHT_COL[3];
               TIME_1 = Time[ Left_4 ]; TIME_2 = Time[ Left_3 ];
               PRICE_1 = (Top_2+Top_3)/2; PRICE_2 = PRICE_1 + LightHeight;
               CreateRectangle(BaseName+ObjIndex, TIME_1, PRICE_1, TIME_2, PRICE_2, COL, Text, BackGround); ObjIndex ++;

               // Light-4
               COL = LIGHT_COL[4];
               TIME_1 = Time[ Right_3 ]; TIME_2 = Time[ Right_4 ];
               PRICE_1 = Top_3; PRICE_2 = PRICE_1 + LightHeight;
               CreateRectangle(BaseName+ObjIndex, TIME_1, PRICE_1, TIME_2, PRICE_2, COL, Text, BackGround); ObjIndex ++;

               // Light-5
               COL = LIGHT_COL[5];
               TIME_1 = Time[ Left_2 ]; TIME_2 = Time[ Left_3 ];
               PRICE_1 = (Top_3+TreeBottom)/2; PRICE_2 = PRICE_1 + LightHeight;
               CreateRectangle(BaseName+ObjIndex, TIME_1, PRICE_1, TIME_2, PRICE_2, COL, Text, BackGround); ObjIndex ++;

               // Light-6
               COL = LIGHT_COL[1];
               TIME_1 = Time[ Right_4 - 4*iWidth_Multiple ]; TIME_2 = Time[ Right_4 - 5*iWidth_Multiple ];
               PRICE_1 = (Top_3+TreeBottom)/2; PRICE_2 = PRICE_1 + LightHeight;
               CreateRectangle(BaseName+ObjIndex, TIME_1, PRICE_1, TIME_2, PRICE_2, COL, Text, BackGround); ObjIndex ++;

               // Light-7
               COL = LIGHT_COL[3];
               TIME_1 = Time[ Left_4 + 3*iWidth_Multiple ]; TIME_2 = Time[ Left_4 + 2*iWidth_Multiple ];
               PRICE_1 = (Top_3+TreeBottom*2)/3; PRICE_2 = PRICE_1 + LightHeight;
               CreateRectangle(BaseName+ObjIndex, TIME_1, PRICE_1, TIME_2, PRICE_2, COL, Text, BackGround); ObjIndex ++;
            }   

            if( !SIGNAL )
            {
               // Light-1
               COL = LIGHT_COL[3];
               TIME_1 = Time[ Right_1 ]; TIME_2 = Time[ Base ];
               PRICE_1 = (TreeTop+Top_2)/2; PRICE_2 = PRICE_1 + LightHeight;
               CreateRectangle(BaseName+ObjIndex, TIME_1, PRICE_1, TIME_2, PRICE_2, COL, Text, BackGround); ObjIndex ++;

               // Light-2
               COL = LIGHT_COL[4];
               TIME_1 = Time[ Left_2 ]; TIME_2 = Time[ Left_1 ];
               PRICE_1 = Top_2; PRICE_2 = PRICE_1 + LightHeight;
               CreateRectangle(BaseName+ObjIndex, TIME_1, PRICE_1, TIME_2, PRICE_2, COL, Text, BackGround); ObjIndex ++;

               // Light-3
               COL = LIGHT_COL[5];
               TIME_1 = Time[ Right_4 ]; TIME_2 = Time[ Right_3 ];
               PRICE_1 = (Top_2+Top_3)/2; PRICE_2 = PRICE_1 + LightHeight;
               CreateRectangle(BaseName+ObjIndex, TIME_1, PRICE_1, TIME_2, PRICE_2, COL, Text, BackGround); ObjIndex ++;

               // Light-4
               COL = LIGHT_COL[4];
               TIME_1 = Time[ Left_3 ]; TIME_2 = Time[ Left_4 ];
               PRICE_1 = Top_3; PRICE_2 = PRICE_1 + LightHeight;
               CreateRectangle(BaseName+ObjIndex, TIME_1, PRICE_1, TIME_2, PRICE_2, COL, Text, BackGround); ObjIndex ++;

               // Light-5
               COL = LIGHT_COL[3];
               TIME_1 = Time[ Right_2 ]; TIME_2 = Time[ Right_3 ];
               PRICE_1 = (Top_3+TreeBottom)/2; PRICE_2 = PRICE_1 + LightHeight;
               CreateRectangle(BaseName+ObjIndex, TIME_1, PRICE_1, TIME_2, PRICE_2, COL, Text, BackGround); ObjIndex ++;

               // Light-6
               COL = LIGHT_COL[2];
               TIME_1 = Time[ Left_4 + 3*iWidth_Multiple ]; TIME_2 = Time[ Left_4 + 4*iWidth_Multiple ];
               PRICE_1 = (Top_3+TreeBottom)/2; PRICE_2 = PRICE_1 + LightHeight;
               CreateRectangle(BaseName+ObjIndex, TIME_1, PRICE_1, TIME_2, PRICE_2, COL, Text, BackGround); ObjIndex ++;

               // Light-7
               COL = LIGHT_COL[1];
               TIME_1 = Time[ Right_4 - 3*iWidth_Multiple ]; TIME_2 = Time[ Right_4 - 2*iWidth_Multiple ];
               PRICE_1 = (Top_3+TreeBottom*2)/3; PRICE_2 = PRICE_1 + LightHeight;
               CreateRectangle(BaseName+ObjIndex, TIME_1, PRICE_1, TIME_2, PRICE_2, COL, Text, BackGround); ObjIndex ++;
            }   
         }
         Prev_SIGNAL = SIGNAL;
      }
      Prev_ShowTree = SHOW_TREE;

      int GV_TEXT_MODE = GlobalVariableGet(sGV_Text_Mode);
      switch(GV_TEXT_MODE)
      {
         //case 1: ObjectDelete(ObjNameBase +"MESSAGE"); break;
         case 1: DrawMessage(); break;
         case 2: DrawLyrics(); break;
         default: ObjectDelete(ObjNameBase +"MESSAGE"); Comment(""); break; //DrawMessage(); break;
      }

      int SHOW_SNOW = GlobalVariableGet(sGV_ShowSnow);
      if(SHOW_SNOW==1) Snowing();

      // Object Delete Check
      if(SHOW_TREE != 1 || SHOW_SNOW != 1)
      for(i=0; i<ObjectsTotal(); i++)
      {
         string OBJ_NAME_i = ObjectName(i);
         if(SHOW_TREE != 1)
         {
            if( StF(OBJ_NAME_i, ObjNameBase +"Leaf_") ) { ObjectDelete(OBJ_NAME_i); continue; }
            if( StF(OBJ_NAME_i, ObjNameBase +"Trunk") ) { ObjectDelete(OBJ_NAME_i); continue; }
            if( StF(OBJ_NAME_i, ObjNameBase +"Star_") ) { ObjectDelete(OBJ_NAME_i); continue; }
            if( StF(OBJ_NAME_i, ObjNameBase +"Ornament_") ) { ObjectDelete(OBJ_NAME_i); continue; }
         }
         if(SHOW_SNOW != 1) if( StF(OBJ_NAME_i, ObjNameBase + "Snow_") ) ObjectDelete(OBJ_NAME_i);
      }

      int GV_SLEEP_MILLISEC = GlobalVariableGet(sGV_Refresh_MilliSec);
      if(GV_SLEEP_MILLISEC < 100) GV_SLEEP_MILLISEC = 100;
   
      Sleep(GV_SLEEP_MILLISEC);

      // Ornament Signal
      MILLISEC_COUNTER += GV_SLEEP_MILLISEC;
      if(MILLISEC_COUNTER > 999)
      {
         if(SIGNAL) SIGNAL = false; else SIGNAL = true;
         MILLISEC_COUNTER = 0;
      }

      WindowRedraw();

   } // while
}

//+------------------------------------------------------------------+
//| DrawMessage                                                      |
//+------------------------------------------------------------------+
void DrawMessage()
{
   int GV_INTERVAL_SEC = GlobalVariableGet(sGV_Text_Interval_Sec); if(GV_INTERVAL_SEC < 2) GV_INTERVAL_SEC = 5;
   int GV_MESSAGE_LANG = GlobalVariableGet(sGV_Select_MessageLang);

   string Message = CustomMessage;
   string CurLang = "Custom";
      
   int LangNum = ArraySize(Multi_Lang)-1;

   if( CustomMessage == "enter your words here" )
   {
      int LANG = GV_MESSAGE_LANG;
      if( GV_MESSAGE_LANG < 1 || GV_MESSAGE_LANG > LangNum ) LANG = 1;
      Message = Multi_Lang [ LANG ]+ " Traders !";
      CurLang = Language [ LANG ];
   }

   if( GV_MESSAGE_LANG == 99 && CustomMessage == "enter your words here" )
   {
      double Timing = ( TimeLocal() % ( LangNum * GV_INTERVAL_SEC) )/GV_INTERVAL_SEC;
      int TIMING = Timing+1;
      Message = Multi_Lang [ TIMING ] + " Traders !";
      CurLang = Language [ TIMING ] ;
   }

   int GV_SHOW_CURLANG = GlobalVariableGet(sGV_ShowCurrentLanguage);
   if(GV_SHOW_CURLANG == 1) Comment( "Language = "+CurLang );
   
   int GV_FONTSIZE = GlobalVariableGet(sGV_Manual_FontSize);
   int GV_CORNER = GlobalVariableGet(sGV_TextCorner);
   int GV_TEXTLINESHIFT = GlobalVariableGet(sGV_TextLineShift);

   int TEXTSHIFT_V = 12+(GV_TEXTLINESHIFT*(GV_FONTSIZE+2));
   int TEXTSHIFT_H = 12;

   string ObjName = ObjNameBase +"MESSAGE";
   string Text = Message; int Corner = GV_CORNER; int X=TEXTSHIFT_H; int Y=TEXTSHIFT_V; string FontName = Font; color COL = FontColor;
   CreateLabel(ObjName, Text, Corner, X, Y, GV_FONTSIZE, FontName, COL);   
}

string Deutsch [] =
{  
"",
"\"Stille Nacht, heilige Nacht\"",
"",
//"1.",
"Stille Nacht, heilige Nacht,",
"Alles schlaft, einsam wacht",
"Nur das traute, hochheilige Paar,",
"Holder Knabe im lockigen Haar",
"Schlafe in himmlischer Ruh!",
"Schlafe in himmlischer Ruh!",
"",
//"2.",
"Stille Nacht, heilige Nacht,",
"Gottes Sohn, o wie lacht",
"Lieb\' aus deinem gottlichen Mund,",
"Da uns schlagt die rettende Stund'",
"Christ, in Deiner Geburt!",
"Christ, in Deiner Geburt!",
"",
//"3.",
"Stille Nacht, heilige Nacht",
"Die der Welt Heil gebracht",
"Aus des Himmels goldenen Hohn",
"Uns der Gnaden Fulle last sehn",
"Jesus in Menschengestalt",
"Jesus in Menschengestalt",
"",
//"4.",
"Stille Nacht, Heilige Nacht",
"Wie sich heut alle Macht",
"vaterlicher Liebe ergos",
"und als Bruder huldvoll umschloss",
"Jesus die Volker der Welt",
"Jesus die Volker der Welt",
"",
//"5.",
"Stille Nacht, heilige Nacht",
"Lange uns schon bedacht",
"als der Herr vom Grimme befreit",
"in der Vater urgrauer Zeit",
"aller Welt Schonung verhies",
"aller Welt Schonung verhies",
"",
//"6.",
"Stille Nacht, heilige Nacht",
"Hirten erst kundgemacht",
"Durch der Engel Alleluja,",
"Tont es laut bei Ferne und Nah:",
"Jesus der Retter ist da!",
"Jesus der Retter ist da!"
};

string English [] =
{  
"",
"\"Silent night, holy night\"",
"",
//"1.",
"Silent night, holy night,",
"All is calm, All is bright",
"Round yon virgin mother and Child.",
"Holy Infant so tender and mild,",
"Sleep in heavenly peace,",
"Sleep in heavenly peace.",
"",
//"2.",
"Silent night, holy night,",
"Shepherds quake at the sight.",
"Glories stream from heaven a far,",
"Heavenly hosts sing al-le-lu-ia;",
"Christ the Savior is born!",
"Christ the Savior is born!",
"",
//"3.",
"Silent night, holy night,",
"Son of God, love\'s pure light",
"Radiant beams from Thy holy face,",
"With the dawn of redeeming grace,",
"Jesus, Lord, at Thy birth,",
"Jesus, Lord, at Thy birth.",
"",
//"4.",
"Silent night! holy night!",
"Where today all the might",
"Of His fatherly love us graced",
"And then Jesus, as brother embraced.",
"All the peoples on earth!",
"All the peoples on earth!",
"",
//"5.",
"Silent night! Holy night!",
"Long we hoped that He might,",
"As our Lord, free us of wrath,",
"Since times of our fathers He hath",
"Promised to spare all mankind!",
"Promised to spare all mankind!",
"",
//"6.",
"Silent night! Holy night!",
"Sheperds first see the sight.",
"Told by angelic Alleluja,",
"Sounding everywhere, both near and far:",
"Christ the Savior is here!",
"Christ the Savior is here!"
};

string Francaise [] =
{  
"",
"\"Nuit de Paix\"",
"",
//"1.",
"O nuit de paix, Sainte nuit",
"Dans le ciel L\'astre luit",
"Dans les champs tout repose en paix",
"Mais soudain dans l\'air pur et frais",
"Le brillant coeur des anges",
"Aux bergers apparait",
"",
//"2.",
"O nuit de foi, Sainte nuit",
"Les bergers sont instruits",
"Confiants dans la voix des cieux",
"Ils s\'en vont adorer leur Dieu",
"Et Jesus, en echange",
"Leur sourit radieux",
"",
//"3.",
"O nuit d\'amour, Sainte nuit",
"Dans l\'etable, aucun bruit",
"Sur la paille, est couche l\'enfant",
"Que la Vierge endort en chantant",
"Il repose en ses langes",
"Son Jesus ravissant",
"",
//"4.",
"O nuit d\'espoir, Sainte nuit",
"L\'esperance a reluit",
"Le Sauveur de la terre est ne",
"C\'est a nous que Dieu l\'a donne",
"Celebrons ses louanges",
"Gloire au Verbe incarne"
};

string Espagnol [] =
{  
"",
"\"Noche de Paz\"",
"",
//"1.",
"Noche de paz, noche de amor,",
"Todo duerme en derredor.",
"Entre sus astros que esparcen su luz",
"Bella anunciando al ninito Jesus",
"Brilla la estrella de paz",
"Brilla la estrella de paz",
"",
//"2.",
"Noche de paz, noche de amor,",
"Todo duerme en derredor",
"Solo velan en la oscuridad",
"Los pastores que en el campo estan;",
"Y la estrella de Belen",
"Y la estrella de Belen",
"",
//"3.",
"Noche de paz, noche de amor,",
"Todo duerme en derredor;",
"sobre el santo nino Jesus",
"Una estrella esparce su luz,",
"Brilla sobre el Rey",
"Brilla sobre el Rey.",
"",
//"4.",
"Noche de paz, noche de amor,",
"Todo duerme en derredor",
"Fieles velando alli en Belen",
"Los pastores, la madre tambien.",
"Y la estrella de paz",
"Y la estrella de paz"
};

string Italiano [] =
{  
"",
"\"Astro del Ciel\"",
"",
//"1.",
"Astro del ciel, Pargol divin,",
"Mite Agnello Redentor!",
"Tu che i Vati da lungi sognar,",
"Tu che angeliche voci nunziar,",
"Luce dona alle genti",
"Pace infondi nei cuor!",
"Luce dona alle genti,",
"Pace infondi nei cuor!",
"",
//"2.",
"Astro del ciel, Pargol divin,",
"Mite Agnello Redentor!",
"Tu di stirpe regale decor,",
"Tu virgineo, mistico fior,",
"Luce dona alle genti,",
"Pace infondi nei cuor!",
"Luce dona alle genti,",
"Pace infondi nei cuor!",
"",
//"3.",
"Astro del ciel, Pargol divin,",
"Mite Agnello Redentor!",
"Tu disceso a scontare l\'error,",
"Tu sol nato a parlare d\'amor,",
"Luce dona alle menti,",
"Pace infondi nei cuor!",
"Luce dona alle genti,",
"Pace infondi nei cuor!"
};

string Norwegian [] =
{  
"",
"\"Glade Jul\"",
"",
//"1.",
"Glade jul, hellige jul!",
"Engler daler ned i skjul.",
"Hit de flyver med paradis gront,",
"hvor de ser hva for Gud er skjont.",
"Lonnlig i blant oss de gar.",
"Lonnlig i blant oss de gar.",

"",
//"2.",
"Julefryd, evig fryd,",
"hellig sang med himmelsk lyd!",
"Det er engler som hyrdene sa,",
"dengang Herren i krybben la.",
"Evig er englenes sang.",
"Evig er englenes sang.",

"",
//"3.",
"Fred pa jord, fryd pa jord,",
"Jesusbarnet i blant oss bor.",
"Engler synger om barnet sa smukt,",
"han har himmeriks dor oppslukt.",
"Salig er englenes sang.",
"Salig er englenes sang.",

"",
//"4.",
"Salig fred, himmelsk fred,",
"toner julenatt herned.",
"Engler bringer til store og sma",
"bud om ham som i krybben la.",
"Fryd deg hver sjel han har frelst!",
"Fryd deg hver sjel han har frelst!"
};

string Tahitian [] =
{  
"",
"\"I te hoe po hau maru\"",
"",
//"1.",
"I te hoe po hau maru",
"Ua fanau mai Iesu, ",
"Ite maira te mau fetia ",
"I te Tamaiti a te Atua",
"Te Arii fanau Api o te taata nei.",
"",
//"2.",
"I te hoe po hau maru",
"Ua fanau mai Iesu",
"Himene maira te mau helahi",
"I te arue--Al--le--lu--ia,",
"Ua fanau te Mesia, oia te Fatu mau.",
};

string Hindi [] =
{  
"",
"\"Khamosh hai raath\'\" ",
"",
//"1.",
"Khamosh hai raath, Bhakth hai raath,",
"Har cheeze hai chup, har cheeze hai saanth,",
"Maa aur bete ke taur per,",
"Dhanya Sishu ko pranam kar,",
"Jes\'u tere janam per, ",
"Jes\'u tere janam per.",
"",
//"2.",
"Khamosh hai raath, Bhakth hai raath,",
"Bhedwan dekhe woh pahali nishan,",
"Pariyon ki geeth Alleluia.",
"Bulaye kinare aur dur se,",
"Dekh, dekho yeh Sishu ko,",
"Jnam liya hai Jes\'u "
};

string Euskera [] =
{  
"",
"\"Gau ixilla, gau donea\'\" ",
"",
//"1.",
"Gau ixilla, gau donea, ",
"Zerutik jetxi da ",
"guazen guztiyok arin arin. ",
"Aingeru eta artzayakin, ",
"gu gatik jayo dalako ",
"Jesus Belenen.",

"",
//"2.",
"Gau erdiyan abesturik ",
"aingeruak zerutik: ",
"Aintza zeruan Jainkoari ",
"pakea lurrean gizonafri, ",
"gu gatik jayo dalako ",
"Jesus Belenen.",

"",
//"3.",
"Gau erdirik, ederna ",
"artzayentzat onena, ",
"aingeru taldea gaba argitzen, ",
"gizonen artean berri ematen, ",
"gu gatik jayo dalako ",
"Jesus Belenen.",

"",
//"4.",
"Artzayakin estalpera ",
"guazen danok batera, ",
"askatxoan dago etzana, ",
"eru lurren Jaun da Jabe, ",
"gu gatik jayo dalako ",
"belengo zoriona.",

"",
//"5.",
"Gau santua, gau donea! ",
"Jainkoa jetxi da ",
"zeru goi - goitik estalpera, ",
"izaretatik seaskatxora, ",
"lo dago Jesus Aurra, ",
"lo dago Jesus Aurra."
};

string Swahili [] =
{  
"",
"\"Usiku Mtakatifu\'\" ",
"",
//"1.",
"Usiku mtakatifu! ",
"Wengine walala ",
"wakeshao ni Yosefu tu ",
"na Maria waliomlinda ",
"Yesu mwana mzuri ",
"Yesu mwana mzuri. ",

"",
//"2.",
"Usiku mtakatifu! ",
"Wachunga wapewa ",
"habari nzuri na malaika, ",
"zienezwe popote sasa: ",
"Yesu mponya kaja ",
"Yesu mponya kaja. ",

"",
//"3.",
"Usiku mtakatifu! ",
"Siku ya furaha ",
"imetuangaza Kimungu ",
"tumeupewa ukombozi ",
"Kristo amefika ",
"Kristo amefika."
};

string Indonesian [] =
{  
"",
"\"Malam Kudus\'\" ",
"",
//"1.",
"",
"Malam kudus, sunyi senyap, ",
"bintang-Mu gemerlap ",
"Jurus\'lamat manusia, ",
"ada datang di dunia ",
"Kristus Anak Daud, ",
"Kristus Anak Daud.",

"",
//"2.",
"Anak kecil, Anak kudus, ",
"Tuhanku Penebus ",
"Tent\'ra surga menyanyi merdu, ",
"bawa kabar kedatangan-Mu ",
"Kristus Anak Daud, ",
"Kristus Anak Daud.",

"",
//"3.",
"Malam kudus, sunyi senyap, ",
"bitang-Mu gemerlap ",
"Aku datang ya Tuhanku, ",
"bersembahyang di kandang-Mu ",
"Dan mengucap syukur, ",
"dan mengucap syukur. "
};

string Maori [] =
{  
"",
"\"Marie te po, tapu te po\'\" ",
"",
//"1.",
"Marie te po, tapu te po,",
"Marino, marama,",
"Ko te Whaea, me te Tama,",
"Tama tino, tapu ra,",
"Moe mai i te aio,",
"Moe mai i te aio.",

"",
//"2.",
"Marie te po, tapu te po,",
"Ka kite nga hepara,",
"Te kororia o te rangi,",
"Me nga ahera Hareruia,",
"Kua whanau te tamaiti,",
"E Ihu te Karaiti."
};

string Hungarian [] =
{  
"",
"\"Csendes Ej\'\" ",
"",
//"1.",
"Csendes ej! Szentseges ej!",
"Mindenek nyugta mely;",
"Nincs fenn mas, csak a Szent szulepar,",
"Draga kisdeduk almainal,",
"Szent Fiu, aludjal, szent Fiu aludjal!",
"",
"Csendes ej! Szentseges ej!",
"Angyalok hangja kel;",
"Halld a mennyei hallelujat,",
"Szerte zengi e draga szavat,",
"Krisztus megszabadit, Krisztus megszabadit!",
"",
"Csendes ej! Szentseges ej!",
"Sziv orulj, higyj, remelj!",
"Isten Szent Fia hinti read,",
"Ajka vigyszt ado mosolyat,",
"Krisztus megszuletett, Krisztus megszuletett!"
};

string Irish [] =
{  
"",
"\"Oiche Chiuin\'\" ",
"",
//"1.",
"Oiche Chiuin, oiche Mhic De, ",
"Cach na suan go heiri an lae. ",
"Dis is dilse ag faire le speis. ",
"Glor binn aingeal le clos insan aer. ",
"Criost ag teacht ar an saol. ",
"Criost ag teacht ar an saol.",

"",
//"2.",
"Oiche Chiuin, oiche Mhic De, ",
"Aoiri ar dtus a chuala an sceal ",
"Alleluia aingeal ag glaoch ",
"Cantain suairc i ngar is i gcein. ",
"Criost ar Slanaitheoir fein ",
"Criost ar Slanaitheoir fein",
};

string Esperanto [] =
{  
"",
"\"Sanktan Nokt\'\" ",
"",
//"1.",
"Paca nokt\', sankta nokt\', ",
"Brila lum\' sur la mont\'; ",
"Jen la Infano kun ama Patrin\'; ",
"Dolae Ti flustras lulante Lin, ",
"Dormu en aiela trankvil\', ",
"Dormu en aiela trankvil\'.\" ",

"",
//"2.",
"Paca nokt\', sankta nokt\', ",
"Tremas tafistoj pro la vid\'; ",
"Gloro fluas en fora aiel\'; ",
"Haleluj\'\" kantas aiu anoel\', ",
"Venis Kris\', la Savanto, ",
"Venis sanktega hel\'!\" ",

"",
//"3.",
"Paca nokt\', sankta nokt\', ",
"Dia fil\', pura bril\'; ",
"Am\' radias de sankta mien\'; ",
"Jen tagio\' de savanta ben\' ",
"Pro naskio\' de l\' Sinjoro, ",
"Pro naskio\' de l\' Sinjor\'. "
};

string HymnLang [] =
{ "",
"Deutsch","English","Francaise","Espagnol","Italiano",
"Norwegian","Tahitian","Hindi", "Euskera","Swahili",
"Indonesian", "Maori","Hungarian","Irish","   ",
"   ","   ","   ","   ", "Esperanto", // 20
"","","","","","","","","","", // 30
"","","","","","","","","","", // 40
"","","","","","","","","","", // 50
"English","English",
};

string LoopMerry [] = {
"Merry Christmas", // ENG
"Joyeux Noel", // FRA
"Feliz Navidad", // ESP
"Froehliche Weihnachten", // GER
"S Rozhdestvom Kristovym", // RUS

"Buon Natale", // ITA
"Shub Badadin", // Hindi
"Sheng Dankuai Le", // Mandarin
"Idah Saidan Wa Sanah Jadidah", // Iraqi
"Mele Kalikimaka", // Hawaiian

"Hauskaa Joulua", // Suomeksi
"Heri ya Krismasi", // Swahili
"Maligayang Pasko", // Tagalog
"Yangi Yiligiz Mubarak Bolsun", // Uzbek
"Velike Vanoce", // Czech
                         
"Kala Christouyenna", // Greek
"Noeliniz Ve Yeni Yiliniz Kutlu Olsun", // Turkish
"Hacahi Ke Eide", // Punjabi
"Zorionak eta Urte Berri On", // Euskera
"Gojan Kristnaskon" // Esperanto
};

string LoopMerryLang [] = {
"English","Francaise","Espagnol","Deutsch","Ruski",
"Italiano","Hindi","Chinese (Mandarin)", "Iraqi","Hawaiian",
"Suomeksi", "Swahili","Tagalog","Uzbek","Czech",
"Greek","Turkish","Punjabi","Euskera", "Esperanto"
};

string WhiteChristmas_ENG [] = {
"",
"\"White Christmas\" ",
"",
// 1
"I\'m dreaming of a white Christmas",
"Just like the ones I used to know",
"Where the treetops glisten,",
"and children listen",
"To hear sleigh bells in the snow",
"",
// 2
"I\'m dreaming of a white Christmas",
"With every Christmas card I write",
"May your days be merry and bright",
"And may all your Christmases be white",
"",
// 3
"I\'m dreaming of a white Christmas ",
"With every Christmas card I write",
"May your days be merry and bright",
"And may all your Christmases be white"
};

string SantaClauseIsComing_ENG[] = {
"",
"\"Santa Claus Is Coming To Town\" ",
"",
// 1
"You better watch out",
"You better not cry",
"Better not pout",
"I\'m telling you why",
"Santa Claus is coming to town",
"",
// 1
"He\'s making a list",
"And checking it twice",
"Gonna find out Who\'s naughty and nice",	
"Santa Claus is coming to town",
"",
// 1
"He sees you when you\'re sleeping",
"He knows when you\'re awake",
"He knows if you\'ve been bad or good",
"So be good for goodness sake!",
"",
// 1
"O! You better watch out!",
"You better not cry",
"Better not pout",
"I\'m telling you why",
"Santa Claus is coming to town",
"Santa Claus is coming to town"
};

//+------------------------------------------------------------------+
//| DrawLyrics                                                       |
//+------------------------------------------------------------------+
void DrawLyrics()
{
   int ARRAY_SIZE;
   
   int GV_SELECT_SONG = GlobalVariableGet(sGV_Select_Song);
   int GV_INTERVAL_SEC = GlobalVariableGet(sGV_Text_Interval_Sec); if(GV_INTERVAL_SEC < 2) GV_INTERVAL_SEC = 5;

   // 1=Deutsch, 2=English, 3=Francaise, 4=Espagnol, 5=Italiano, 6=Norwegian, 7=Tahitian, 8=Hindi, 9=Euskera 10=Swahili
   // 11=Indonesian, 12=Maori, 13=Hungarian, 14=Irish, 20=Esperanto
   switch(GV_SELECT_SONG)
   {
      case 1: ARRAY_SIZE = ArraySize(Deutsch); break;
      case 2: ARRAY_SIZE = ArraySize(English); break;
      case 3: ARRAY_SIZE = ArraySize(Francaise); break;
      case 4: ARRAY_SIZE = ArraySize(Espagnol); break;
      case 5: ARRAY_SIZE = ArraySize(Italiano); break;
      case 6: ARRAY_SIZE = ArraySize(Norwegian); break;
      case 7: ARRAY_SIZE = ArraySize(Tahitian); break;
      case 8: ARRAY_SIZE = ArraySize(Hindi); break;
      case 9: ARRAY_SIZE = ArraySize(Euskera); break;
      case 10: ARRAY_SIZE = ArraySize(Swahili); break;
      case 11: ARRAY_SIZE = ArraySize(Indonesian); break;
      case 12: ARRAY_SIZE = ArraySize(Maori); break;
      case 13: ARRAY_SIZE = ArraySize(Hungarian); break;
      case 14: ARRAY_SIZE = ArraySize(Irish); break;
      case 20: ARRAY_SIZE = ArraySize(Esperanto); break;
      
      case 51: ARRAY_SIZE = ArraySize(WhiteChristmas_ENG); break;
      case 52: ARRAY_SIZE = ArraySize(SantaClauseIsComing_ENG); break;
      
      case 99: ARRAY_SIZE = ArraySize(LoopMerry); break;
      default: ARRAY_SIZE = ArraySize(Deutsch); break;
   }

   string Text;

   double Timing = ( TimeLocal() % (ARRAY_SIZE * GV_INTERVAL_SEC) ) / GV_INTERVAL_SEC;
   int TIMING = Timing;

   if(CurTiming == TIMING) return(0);
   CurTiming = TIMING;

   string CurLang;
   if(GV_SELECT_SONG != 99) CurLang = HymnLang [ GV_SELECT_SONG ];
   if(GV_SELECT_SONG == 99) CurLang = LoopMerryLang [ TIMING ];

   string ObjName = ObjNameBase +"MESSAGE";
   ObjectDelete(ObjName);

   if( Text != "" )
   {
      int GV_RANDOMIZE = GlobalVariableGet(sGV_Randomize);

      if(GV_RANDOMIZE != 1)
      {
         int GV_FONTSIZE = GlobalVariableGet(sGV_Manual_FontSize);
         int GV_CORNER = GlobalVariableGet(sGV_TextCorner);
         int GV_TEXTLINESHIFT = GlobalVariableGet(sGV_TextLineShift);
         int FONTSIZE = GV_FONTSIZE;
         int CORNER = GV_CORNER % 4;
         int TEXTSHIFT_V = 12+(GV_TEXTLINESHIFT*(GV_FONTSIZE+2));
         int TEXTSHIFT_H = 12;
      }
      else
      {
         MathSrand(TimeLocal());
         CORNER = MathRand() % 4;
         TEXTSHIFT_V = (MathRand() % 200) + 12;
         TEXTSHIFT_H = (MathRand() % 200) + 12;
         int GV_TEXT_MAX = GlobalVariableGet(sGV_RndText_Max);
         int GV_TEXT_MIN = GlobalVariableGet(sGV_RndText_Min);
         FONTSIZE = (MathRand() % (GV_TEXT_MAX - GV_TEXT_MIN)) + GV_TEXT_MIN;
      }

   switch(GV_SELECT_SONG)
   {
      case 1: Text = Deutsch [ TIMING ]; break;
      case 2: Text = English [ TIMING ]; break;
      case 3: Text = Francaise [ TIMING ]; break;
      case 4: Text = Espagnol [ TIMING ]; break;
      case 5: Text = Italiano [ TIMING ]; break;
      case 6: Text = Norwegian [ TIMING ]; break;
      case 7: Text = Tahitian [ TIMING ]; break;
      case 8: Text = Hindi [ TIMING ]; break;
      case 9: Text = Euskera [ TIMING ]; break;
      case 10: Text = Swahili [ TIMING ]; break;
      case 11: Text = Indonesian [ TIMING ]; break;
      case 12: Text = Maori [ TIMING ]; break;
      case 13: Text = Hungarian [ TIMING ]; break;
      case 14: Text = Irish [ TIMING ]; break;
      case 20: Text = Esperanto [ TIMING ]; break;

      case 51: Text = WhiteChristmas_ENG [ TIMING ]; break;
      case 52: Text = SantaClauseIsComing_ENG [ TIMING ]; break;

      case 99: Text = LoopMerry [ TIMING ] + " Traders !"; break;
      default: Text = Deutsch [ TIMING ]; CurLang = HymnLang [ 1 ]; break;
   }

   Comment("");
   int GV_SHOW_CURLANG = GlobalVariableGet(sGV_ShowCurrentLanguage);
   if(GV_SHOW_CURLANG == 1) Comment( "Language = " + CurLang );

   int Corner = CORNER; int X=TEXTSHIFT_H; int Y=TEXTSHIFT_V; int Font_Size = FONTSIZE; string FontName = Font; color COL = FontColor;
   CreateLabel(ObjName, Text, Corner, X, Y, Font_Size, FontName, COL);   

   }
}

//+------------------------------------------------------------------+
//| Snowing
//+------------------------------------------------------------------+
void Snowing()
{   
   int i;

   int SNOW_FLAKES = GlobalVariableGet(sGV_SnowFlakes);

   if(Prev_SnowFlakes != SNOW_FLAKES)
   {
      ArrayResize(x, SNOW_FLAKES);
      ArrayResize(y, SNOW_FLAKES);
      ArrayResize(size, SNOW_FLAKES);
      ArrayResize(Dir, SNOW_FLAKES);
      ArrayResize(j, SNOW_FLAKES);
      ArrayResize(Speed, SNOW_FLAKES);
      ArrayResize(Amplitude, SNOW_FLAKES);

      if(Prev_SnowFlakes > SNOW_FLAKES)
      for(i=0; i<10 ;i++) for(i=SNOW_FLAKES; i<Prev_SnowFlakes; i++) ObjectDelete(ObjNameBase + "Snow_"+i);
   }
   Prev_SnowFlakes = SNOW_FLAKES;
   
   double SCALE_FACTOR = GlobalVariableGet(sGV_Scale_Factor);

   MathSrand(GetTickCount());

   // Create New Snow Flake
   for(i=0; i<SNOW_FLAKES ;i++)
   {
      string ObjName = ObjNameBase + "Snow_"+i;

      if(ObjectFind(ObjName) == -1 || y[i] < WindowPriceMin())
      {
         int iRandom = MathRand();
         x[i] = (iRandom % (WindowBars-30)) +15;
         double RandSize = ((iRandom % 50)+50)*0.0005;
            
         size[i] = Window_Range * RandSize;
         y[i] = WindowPriceMax()+size[i]*(iRandom % 5);

         datetime TIME_1 = Time[ x[i] ]; datetime TIME_2 = TIME_1;
         double PRICE_1 = y[i]; double PRICE_2 = y[i] + size[i];
         CreateEllipse(ObjName, TIME_1, PRICE_1, TIME_2, PRICE_2, White, "", SCALE_FACTOR, true);
         
         Speed[i] = (iRandom % 10)+5;
         Amplitude[i] = (iRandom % 15)+5;
         j[i] = iRandom % Amplitude[i]; Dir[i] = iRandom % 2;
      }

      y[i] -= Speed[i] *DQADJ*Point;

      if(j[i] == Amplitude[i]) Dir[i] = 1;
      if(j[i] == 0) Dir[i] = 0;
      if(Dir[i] == 0) j[i]++;
      if(Dir[i] == 1) j[i]--;
      x[i] += j[i]-5;

      if(x[i]<2) ObjectDelete(ObjName);

      if(ObjectFind(ObjName) != -1)
      {
         ObjectMove(ObjName,0,Time[ x[i] ],y[i]);
         ObjectMove(ObjName,1,Time[ x[i] ],y[i]+size[i]);
         ObjectSet(ObjName,OBJPROP_SCALE,SCALE_FACTOR);
      }
   }
}

//+------------------------------------------------------------------+
//| Range_and_Bar_Reset
//+------------------------------------------------------------------+
void Range_and_Bar_Reset()
{
   Window_Range = WindowPriceMax() - WindowPriceMin();
   WindowBars = WindowBarsPerChart();
   //double d_WindowBars = WindowBarsPerChart();
   //double d_WindowBars = WindowBarsPerChart()*0.75;
   //WindowBars = d_WindowBars;
}

//+------------------------------------------------------------------+
//| Create Label (void)
//+------------------------------------------------------------------+
void CreateLabel(string ObjName, string Text, int Corner, int X, int Y, int FontSize, string FontName, color COL)
{
   if(ObjectFind(ObjName) != -1) ObjectDelete(ObjName);
   
   ObjectCreate(ObjName, OBJ_LABEL, 0, 0, 0);
   ObjectSet(ObjName, OBJPROP_CORNER, Corner);
   ObjectSet(ObjName, OBJPROP_XDISTANCE, X);
   ObjectSet(ObjName, OBJPROP_YDISTANCE, Y);       
   ObjectSetText(ObjName, Text, FontSize, FontName, COL);
}

//+------------------------------------------------------------------+
//| CreateTriangle (void)
//+------------------------------------------------------------------+
void CreateTriangle(string ObjName, datetime TIME_1, double PRICE_1, datetime TIME_2, double PRICE_2, datetime TIME_3, double PRICE_3, color COL, string Text, bool BackGround)
{
   if(ObjectFind(ObjName) != -1) ObjectDelete(ObjName);
   
   ObjectCreate(ObjName,OBJ_TRIANGLE, 0, TIME_1, PRICE_1, TIME_2, PRICE_2, TIME_3, PRICE_3 );
   ObjectSet(ObjName,OBJPROP_COLOR,COL);
   ObjectSet(ObjName,OBJPROP_BACK,BackGround);
   ObjectSetText(ObjName, Text); // description
}

//+------------------------------------------------------------------+
//| CreateRectangle (void)
//+------------------------------------------------------------------+
void CreateRectangle(string ObjName, datetime TIME_1, double PRICE_1, datetime TIME_2, double PRICE_2, color COL, string Text, bool BackGround)
{
   if(ObjectFind(ObjName) != -1) ObjectDelete(ObjName);
   
   ObjectCreate(ObjName,OBJ_RECTANGLE, 0, TIME_1, PRICE_1, TIME_2, PRICE_2 );
   ObjectSet(ObjName,OBJPROP_COLOR,COL);
   ObjectSet(ObjName,OBJPROP_BACK,BackGround);
   ObjectSetText(ObjName, Text); // description
}

//+------------------------------------------------------------------+
//| CreateEllipse (void)
//+------------------------------------------------------------------+
void CreateEllipse(string ObjName, datetime TIME_1, double PRICE_1, datetime TIME_2, double PRICE_2, color COL, string Text, double SCALE, bool BackGround)
{
   if(ObjectFind(ObjName) != -1) ObjectDelete(ObjName);
   
   ObjectCreate(ObjName,OBJ_ELLIPSE,0,TIME_1, PRICE_1, TIME_2, PRICE_2);
   ObjectSet(ObjName,OBJPROP_SCALE, SCALE);
   ObjectSet(ObjName,OBJPROP_COLOR, COL);
   ObjectSetText(ObjName, Text);

   ObjectSet(ObjName,OBJPROP_BACK,BackGround);
}

//+------------------------------------------------------------------+
//| DelObjects
//+------------------------------------------------------------------+
void DelObjects(string ObjID)
{
   for(int i=0; i<ObjectsTotal(); i++) if( StF(ObjectName(i), ObjID) ) ObjectDelete(ObjectName(i));
   WindowRedraw();
}

bool StF(string TEXT, string TEXT_to_Find) { if(TEXT_to_Find == "") return(false); if( StringFind(TEXT, TEXT_to_Find) != -1 ) return(true); else return(false); }

